using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Transactions;
namespace CMSMicroservice.Protobuf.Validator.Transactions;

public class GetAllTransactionsByFilterRequestValidator : AbstractValidator<GetAllTransactionsByFilterRequest>
{
    public GetAllTransactionsByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllTransactionsByFilterRequest>.CreateWithOptions((GetAllTransactionsByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
